<template>
  <div
    v-loading.fullscreen.lock="fullscreenLoading"
    class="userManagement_list"
  >
    <div class="userManagement_list_headerSelect">
      <el-form slot="form" style="display: inline" inline :addList="true">
        <el-form-item class="header_top_form" label="账号：">
          <el-input
            placeholder="请输入"
            size="small"
            v-model.trim="form.account"
            clearable
          ></el-input>
        </el-form-item>
        <el-form-item class="header_top_form" label="姓名：">
          <el-input
            placeholder="请输入"
            size="small"
            v-model.trim="form.name"
            clearable
          ></el-input>
        </el-form-item>
        <el-form-item>
          <el-button
            size="small"
            type="primary"
            style="width: 88px"
            @click="search"
            >查询</el-button
          >
        </el-form-item>
      </el-form>
      <el-button
        size="small"
        style="width: 104px; margin-right: 23px"
        @click="addList"
        >新增</el-button
      >
    </div>
    <el-table
      :data="tableData"
      style="width: 100%"
      stripe
      :header-cell-style="{ background: '#F7F7F7' }"
      height="66vh"
    >
      <el-table-column
        v-for="(item, index) in listData"
        :key="index"
        :label="item.name"
        :prop="item.value"
        :width="item.width"
        :min-width="item.minWidth"
        :align="item.align"
      >
        <template slot-scope="scope">
          <div>
            <div v-if="item.value == 'status'">
              <el-switch
                v-model="scope.row[scope.column.property]"
                active-color="#17A8FF"
                inactive-color="#AFAFAF"
                @change="statusChange($event, scope.row)"
              >
              </el-switch>
            </div>
            <div v-else>
              {{ scope.row[scope.column.property] }}
            </div>
          </div>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center">
        <template slot-scope="scope">
          <div>
            <el-button type="text" @click="edit(scope.row)">编辑</el-button>
            <el-button
              type="text"
              @click="resetPasswords(scope.row)"
              style="color: #f4453e"
              >重置密码</el-button
            >
          </div>
        </template>
      </el-table-column>
    </el-table>
    <el-pagination
      @size-change="handleSizeChange"
      @current-change="handleCurrentChange"
      :current-page="form.pageNum"
      :page-sizes="[100, 200, 300, 400]"
      :page-size="form.pageSize"
      background
      layout="total,prev, pager, next,jumper"
      :total="form.total"
    >
    </el-pagination>
    <editDialog ref="editDialogRefs" />
    <detailDialog ref="detailDialogRefs" />
  </div>
</template>
<script>
import editDialog from './edit'
import detailDialog from './detail'
import * as api from '@/api/api'
export default {
  name: 'userManagement',
  components: {
    editDialog,
    detailDialog
  },
  data() {
    return {
      fullscreenLoading: false,
      tableData: [],
      listData: [
        {
          name: '账号',
          value: 'account',
          width: '',
          minWidth: '',
          align: 'center'
        },
        {
          name: '姓名',
          value: 'name',
          width: '',
          minWidth: '',
          align: 'center'
        },
        {
          name: '禁用/启用',
          value: 'status',
          width: '',
          minWidth: '',
          align: 'center'
        },
        {
          name: '创建时间',
          value: 'createTime',
          width: '',
          minWidth: '',
          align: 'center'
        }
      ],
      form: {
        pageNum: 1,
        pageSize: 10,
        account: '',
        name: '',
        start: '',
        total: 0
      }
    }
  },
  mounted() {
    this.listDataInit()
  },
  methods: {
    /**
     * @method 搜索
     * **/
    search() {
      this.form.pageNum = 1
      this.listDataInit()
    },
    /**
     * @method 用户数据列表
     * **/
    listDataInit() {
      this.fullscreenLoading = true
      let code = {
        account: this.form.account,
        name: this.form.name,
        page: this.form.pageNum,
        pageSize: this.form.pageSize,
        start: this.form.start
      }
      api
        .POST('/user/list', code)
        .then(res => {
          if (res.code == 0) {
            this.tableData = res.data.list
            this.tableData.forEach(item => {
              item.status == 1 ? (item.status = true) : (item.status = false)
            })
            this.form.pageNum = res.data.currPage
            this.form.pageSize = res.data.pageSize
            this.form.total = res.data.totalCount
            this.fullscreenLoading = false
          }
        })
        .catch(() => {
          this.fullscreenLoading = false
        })
    },
    /**
     * @method 条数分页
     * **/
    handleSizeChange(val) {
      this.form.pageSize = val
      this.form.pageNum = 1
      this.listDataInit()
    },
    /**
     * @method 分页
     * **/
    handleCurrentChange(val) {
      this.form.pageNum = val
      this.listDataInit()
    },
    /**
     * @method 新增
     * **/
    addList() {
      let code = {
        title: '新增用户',
        show: true
      }
      this.$refs.editDialogRefs.openClose(code)
    },
    // 编辑
    edit(val) {
      let code = {
        title: '编辑用户',
        show: false,
        id: val.userId
      }
      this.$refs.editDialogRefs.openClose(code)
    },
    // 重置密码
    resetPasswords(val) {
      let code = {
        id: val.userId
      }
      this.$refs.detailDialogRefs.openClose(code)
    },
    /**
     * @method 状态修改
     * **/
    statusChange(val, item) {
      val ? (val = 1) : (val = 0)
      let code = {
        id: item.userId,
        status: val
      }
      api.PUT('/user/updateSwitch', code).then(data => {
        if (data.code == 0) {
          this.search()
          this.$message.success(data.message)
        }
      }).catch(()=>{
        this.search()
      })
    }
  }
}
</script>
<style lang="less">
.userManagement_list {
  .userManagement_list_headerSelect {
    display: flex;
    justify-content: space-between;
    align-items: center;
    margin-bottom: 32px;
    .el-form-item {
      margin-bottom: 0;
      margin-right: 60px;
      .el-input__inner {
        background: #f5f5f5;
        opacity: 1;
        border-radius: 17px;
      }
    }
  }
}
</style>